package org.nick.wwwjdic;

import org.nick.wwwjdic.client.WwwjdicClient;
import org.nick.wwwjdic.model.KanjiEntry;
import org.nick.wwwjdic.model.SearchCriteria;


public class KanjiSearchTask extends BackdoorSearchTask<KanjiEntry> {

    public KanjiSearchTask(String url, int timeoutSeconds,
            ResultList<KanjiEntry> resultListView, SearchCriteria criteria) {
        super(url, timeoutSeconds, resultListView, criteria);
    }

    @Override
    protected KanjiEntry parseEntry(String entryStr) {
        return KanjiEntry.parseKanjidic(entryStr.trim());
    }

    @Override
    protected String generateBackdoorCode(SearchCriteria criteria) {
        return WwwjdicClient.generateKanjiBackdoorCode(criteria);
    }
}
